﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Diagnostics;
using Infragistics.Windows.DataPresenter;

namespace RecordIndexXDG
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        ObservableCollection<Types> source = new ObservableCollection<Types>();



        public int DummyValue
        {
            get { return (int)GetValue(DummyValueProperty); }
            set { SetValue(DummyValueProperty, value); }
        }
        public static readonly DependencyProperty DummyValueProperty =
            DependencyProperty.Register("DummyValue", typeof(int), typeof(Window1), new UIPropertyMetadata(0));

        public Window1()
        {
            InitializeComponent();

            for (int i = 0; i < 10; i++)
                source.Add(new Types(i));

            xamDataGrid1.DataSource = source;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            Random random = new Random();
            int index = random.Next(0, source.Count - 1);
            source.Insert(index,new Types());
            Debug.WriteLine("----------");
            this.DummyValue++;
        }
    }
    public class Types
    {
        public int Integer { get; set; }
        public double Double { get; set; }
        public decimal Currency { get; set; }
        public DateTime DateTime { get; set; }
        public Types()
        {
        }
        public Types(int seed)
        {
            this.Integer = new Random(seed).Next(0, 1000);
            this.Double = new Random(seed).NextDouble();
            this.Currency = decimal.Parse(new Random(seed).Next().ToString());
            this.DateTime = DateTime.Now.AddDays(seed);
        }
    }

    public class MyConverter : IMultiValueConverter
    {
        #region IMultiValueConverter Members

        public object Convert(object[] values, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (values != null && values[0] != null)
            {
				Record r = values[0] as Record;
				return r.VisibleIndex.ToString();
            }
            else
                return null;
        }

        public object[] ConvertBack(object value, Type[] targetTypes, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }

        #endregion
    }

}
